package com.pruebasaplicacion.sergimeli.bletests;
import android.Manifest;
import android.annotation.TargetApi;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothGatt;
import android.bluetooth.BluetoothGattCallback;
import android.bluetooth.BluetoothGattCharacteristic;
import android.bluetooth.BluetoothGattDescriptor;
import android.bluetooth.BluetoothManager;
import android.bluetooth.BluetoothProfile;
import android.bluetooth.le.BluetoothLeScanner;
import android.bluetooth.le.ScanCallback;
import android.bluetooth.le.ScanFilter;
import android.bluetooth.le.ScanResult;
import android.bluetooth.le.ScanSettings;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.database.Cursor;
import android.database.DatabaseUtils;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.support.v4.app.ActivityCompat;
import android.util.Log;
import android.util.SparseArray;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.RelativeLayout;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;
import java.lang.Math;

import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.UUID;

import com.pruebasaplicacion.sergimeli.bletests.adapters.ColoredTextAdapter;
import com.pruebasaplicacion.sergimeli.bletests.adapters.SimpleSpinnerTextAdapter;
import com.pruebasaplicacion.sergimeli.bletests.adapters_models.Devices;
import com.pruebasaplicacion.sergimeli.bletests.adapters_models.Users;
import com.pruebasaplicacion.sergimeli.bletests.modelo.DatosDispositivo;
import com.pruebasaplicacion.sergimeli.bletests.modelo.RendimientoUsuario;
import com.pruebasaplicacion.sergimeli.bletests.modelo.Usuario;
import com.pruebasaplicacion.sergimeli.bletests.sqlite.BaseDatosDispositivo;
import com.pruebasaplicacion.sergimeli.bletests.sqlite.DeviceContract;
import com.pruebasaplicacion.sergimeli.bletests.sqlite.OperacionesBaseDatos;

@TargetApi(21)
public class MainActivity extends Activity implements SensorEventListener {

    /** CONSTANTES **/
    private int REQUEST_ENABLE_BT = 1;
    private static final double USER_CAL_RATIO = 0.63;
    private static final double KM_TO_MILE_RATIO = 0.621371;
    private static final long SCAN_PERIOD = 10000;
    private static final int PERMISSION_REQUEST_COARSE_LOCATION = 1;
    private static final String TAG = "Bletests"; //Name of the app
    public static final String SENT_MDEVICE = "com.pruebasaplicacion.sergimeli.bletests.MDEVICE";

    /** Bluetooth **/
    private BluetoothLeScanner mLEScanner;
    private ScanSettings settings;
    private List<ScanFilter> filters;
    private BluetoothGatt mGatt;
    private BluetoothDevice mbtDevice;

    /** Vistas **/
    private ListView mListView;
    private Activity mActivity;
    private TextView mTitleUserInterface;
    private LinearLayout mUserInterface;
    private Button mStartActivity, mStopActivity;
    private ImageButton mChallengeButton, mUserRecapButton, mUserConfigButton, mDeleteButton, mScanButton;

    /** Strings **/
    private String[] mString = {"", ""};
    private String[] mUsers = new String[5];
    private String[] mDevices_detected = new String[5];
    private String mScanResult;
    private String firstArray[];
    private String secondArray[];
    private String thirdArray[];
    private String mTodayChallenge;
    private String mDevice, mServiceUUID, mDeviceName, mGivenName, mSelectedUser, mSelectedId;
    private String mToday, mYesterday;
    private String mDeviceNameDefault;
    private String mActivityDate;
        //Strings para la administración de borrado
        private String deleteName;
        private String deleteDevice;

    /** Arrays **/
    private SparseArray<BluetoothDevice> mDevices;

    /** BOOLEAN FLAGS **/
    private boolean AndroidSensorBooted = false;
    private boolean IsSensorStarted = true;

    /** FLOAT Y DOUBLE **/
    private float mAccX=0, mAccY=0, mAccZ=0,
                  mGyroX=0, mGyroY=0, mGyroZ=0;
    private double[] mInclinationAngle = new double[2];
    private double mStartTime = 0, mFinishTime;

    /** INT **/
    private int mCountBadStep = 0,mCountBadStep2 = 0, mCountHeavySteps = 0, mCountSteps = 0;
    private int mOffsetCountStep = 0;
    private int howManyUsers = 0, howMuchIds = 0, howManyDevices = 0;
    private int mTodaysChallenge = 0;

    /** BD **/
    private OperacionesBaseDatos datos;
    private BaseDatosDispositivo mBase;

    /** OTRAS **/
    Calendar mCalendar;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        /** Inicialización de las vistas de escaneo **/
        mListView = (ListView) findViewById(R.id.btlistView);
        mActivity = this;
        mScanButton = (ImageButton) findViewById(R.id.scanButton);

        /** Uso de otras **/
        mCalendar = Calendar.getInstance();

        /** User interface layout **/
        mUserInterface = (LinearLayout)findViewById(R.id.UserInterfaceLayout);
        mStartActivity = (Button)findViewById(R.id.StartActivityButton);
        mStartActivity.setEnabled(false);
        mStopActivity = (Button)findViewById(R.id.StopActivityButton);
        mStopActivity.setEnabled(false);
        mChallengeButton = (ImageButton)findViewById(R.id.ChallengeImageButton);
        mChallengeButton.setEnabled(false);
        mUserRecapButton = (ImageButton)findViewById(R.id.UserRecapImageButton);
        mUserRecapButton.setEnabled(false);
        mUserConfigButton = (ImageButton)findViewById(R.id.UserConfigurationImageButton);
        mUserConfigButton.setEnabled(false);
        mDeleteButton = (ImageButton)findViewById(R.id.UserDeleteImageButton);
        mDeleteButton.setEnabled(false);
        mTitleUserInterface = (TextView)findViewById(R.id.UserInterfaceTextTitle);

        //Sensores del móvil
        mSensorManager = (SensorManager) getSystemService(Context.SENSOR_SERVICE);
        mStepCounterSensor = mSensorManager.getDefaultSensor(Sensor.TYPE_STEP_COUNTER);
        mStepDetectorSensor = mSensorManager.getDefaultSensor(Sensor.TYPE_STEP_DETECTOR);
        mOffsetCountStep = 0;
        mCountBadStep = 0;
        mCountHeavySteps = 0;
        mCountBadStep2 = 0;

        /** Proporcionar el nombre default de los dispositivos mediante los strings **/
        mDeviceNameDefault = getString(R.string.DeviceNameDefault);

        //Reseteo de flags
        AndroidSensorBooted = false;
        IsSensorStarted = true;

        /** Inicialización y creación de la base de datos **/
        datos = OperacionesBaseDatos.obtenerInstancia(getApplicationContext());
        mBase = new BaseDatosDispositivo(this);
        /**
         * Comprobar que a la aplicación se le permite el uso de la localización del dispositivo
         * móvil
         */

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M){
            //Android M Permission check
            if(this.checkSelfPermission(Manifest.permission.ACCESS_COARSE_LOCATION)!=PackageManager.PERMISSION_GRANTED){
                //Creación de la alerta de dialogo
                final AlertDialog.Builder builder = new AlertDialog.Builder(this);
                builder.setTitle(getString(R.string.locationAccessTitle));
                builder.setMessage(R.string.locationAccessDescription);
                builder.setPositiveButton(android.R.string.ok, null);
                builder.setOnDismissListener(new DialogInterface.OnDismissListener() {
                                                 @Override
                                                 public void onDismiss(DialogInterface dialog) {
                                                     //Aunque no se acepte la localización la activamos, si no el dispositivo no iria
                                                    ActivityCompat.requestPermissions(mActivity,
                                                            new String[]{Manifest.permission.ACCESS_COARSE_LOCATION},
                                                            PERMISSION_REQUEST_COARSE_LOCATION);
                                                 }

                });
                builder.show();

            }
        }

        /** Comprobar que el BLE se puede usar **/
        if (!getPackageManager().hasSystemFeature(PackageManager.FEATURE_BLUETOOTH_LE)) {
            Toast.makeText(this, getString(R.string.BLEisNotSupported),
                    Toast.LENGTH_SHORT).show();
            finish();
        }

        /** Inicialización del adaptador de Bluetooth **/
        final BluetoothManager bluetoothManager =
                (BluetoothManager) getSystemService(Context.BLUETOOTH_SERVICE);
        mBluetoothAdapter = bluetoothManager.getAdapter();

        /** LOG de dispositivos **/
        mDevices = new SparseArray<BluetoothDevice>();

        /** Creación del cuadro de dialogo **/
        mProgress = new ProgressDialog(this);
        mProgress.setIndeterminate(true);
        mProgress.setCancelable(false);

        //Comprobar cuantos usuarios y dispositivos hay en la base de datos
        calculateHowManyDevices();
        calculateHowManyUsers();

        //Conseguir usuarios y dispositivos
        mUsers = getAllExistentUsersforSpinner();
        mDevices_detected = getAllExistentDevicesforSpinner();

    }

    @Override
    protected void onResume() {
        super.onResume();
        //Comprobar que el Bluetooth esta activado en el móvil
        if (mBluetoothAdapter == null || !mBluetoothAdapter.isEnabled()) {
            Intent enableBtIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
            startActivityForResult(enableBtIntent, REQUEST_ENABLE_BT);
        } else {
            if (Build.VERSION.SDK_INT >= 21) {
                mLEScanner = mBluetoothAdapter.getBluetoothLeScanner();
                settings = new ScanSettings.Builder()
                        .setScanMode(ScanSettings.SCAN_MODE_BALANCED)
                        .build();
                filters = new ArrayList<ScanFilter>();
            }
        }
    }

    @Override
    protected void onPause() {
        super.onPause();
        // Si hay conexión, desactivar el escaneo
        if (mBluetoothAdapter != null && mBluetoothAdapter.isEnabled()) {
            scanLeDevice(false);
        }
        mProgress.dismiss();
        mHandler.removeCallbacks(mStopRunnable);
        mHandler.removeCallbacks(mStartRunnable);
        //scanLeDevice(false);
    }

    @Override
    protected void onStop() {
        super.onStop();
        //Desconectar de cualquier actividad encontrada
        if(mConnectedGatt != null){
            mConnectedGatt.disconnect();
            mConnectedGatt = null;
        }
    }
    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (mGatt == null) {
            return;
        }
        mGatt.close();
        mGatt = null;

    }

    /**
     * Este método se activará cada vez que se detecte una actividad en el dispositivo
     * @param requestCode Código enviado del móvil al dispositivo
     * @param resultCode Código devuelto del dispositivo al móvil
     * @param data Datos recogidos de la actividad del dispositivo, mostrando sus caracteristicas
     */
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == REQUEST_ENABLE_BT) {
            if (resultCode == Activity.RESULT_CANCELED) {
                //Bluetooth not enabled.
                finish();
                return;
            }
        }
        super.onActivityResult(requestCode, resultCode, data);
    }

    /**
     * El siguiente método mostrará la lista de dispositivos. Estos se mostrarán a condición de
     * que al menos haya un dispositivo.
     */

    public void mostrarListView(){
        mString[0] = mbtDevice.toString();
        if(mListView.getAdapter() == null) {
            if (mString[0] == null || mString[0].equals("")) { //Comprobar existencia de al menos un dispositivo
            } else {

                Devices device_data[] = new Devices[] //Creación de los datos a pasar de la ListView
                        {
                                new Devices(R.drawable.icono_pulsera, mGivenName, mDevice, mDeviceName) //Icono + Nombre + Beacon + Nombre dispositivo
                        };
                ColoredTextAdapter adapter = new ColoredTextAdapter(this, //Creación del adaptador
                        R.layout.listview_item_row, device_data);
                View header = (View) getLayoutInflater().inflate(R.layout.listview_header_row, null);
                mListView.addHeaderView(header); //Añadir cabecera del adaptador
                mListView.setAdapter(adapter); //Aplicación del adaptador a la listView

            }
            //Designar un evento de OnItemClick para cada elemento de la ListView
            mListView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
                @Override
                public void onItemClick(AdapterView<?> parent, View view, int position, long id) {

                    if (mGivenName.equals(getString(R.string.DeviceNameDefault))) {
                        //Si el dispositivo contiene el nombre default, se instará al usuario a crear un usuario mediante un AlertDialog
                        final AlertDialog.Builder builder = new AlertDialog.Builder(MainActivity.this);
                        builder.setTitle(getString(R.string.newDeviceDetectedAlertTitle));
                        builder.setMessage(getString(R.string.newDeviceDetectedAlertDescription));
                        builder.setPositiveButton(android.R.string.ok, null);
                        builder.setOnDismissListener(new DialogInterface.OnDismissListener() {
                            @Override
                            public void onDismiss(DialogInterface dialog) {
                                //Comenzar actividad NewDeviceActivity, para la creación de usuario
                                Intent intent = new Intent(MainActivity.this, NewDeviceActivity.class);
                                intent.putExtra(SENT_MDEVICE, mDevice); //Envio de datos a la otra actividad
                                scanLeDevice(false); //Desactivar el escaneo de dispositivos
                                startActivity(intent);
                            }

                        });
                        builder.show();

                    } else {
                        //Crear el dialogo de alerta
                        final Dialog dialog = new Dialog(MainActivity.this);
                        //Le asignamos un layout customizado
                        dialog.setContentView(R.layout.selected_user_dialog);
                        dialog.setTitle("User select");
                        //Cambiamos el texto dinámico necesário, en este caso, los datos del spinner
                        Spinner spinner = (Spinner) dialog.findViewById(R.id.Select_a_user_spinner);
                        //Comprobación de que existe al menos un usuario
                        if (mUsers!=null) {
                            String[] aux = getAllExistentUsersforSpinner(); //Se consiguen todos los nombres
                            //Se crea una data de usarios de igual tamaño que el número de usuarios encontrados
                            Users users_data[] = new Users[aux.length];
                            for(int i = 0; i < aux.length; i++){

                                        users_data[i] = new Users(aux[i]); //Asignación de cada Usuario en el data
                            }
                            // Creación del adaptor simple del desplegable, pasándole como parámetro el user_data
                            SimpleSpinnerTextAdapter adapter_selected = new SimpleSpinnerTextAdapter(MainActivity.this,
                                    R.layout.listview_simple_user_format, users_data);
                            adapter_selected.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
                            // Asignar el adaptador al spinner seleccionado
                            spinner.setAdapter(adapter_selected);
                        }

                        // Añadir un listener de OnItemSelected al desplegable
                        spinner.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
                            @Override
                            public void onItemSelected(AdapterView<?> adapterView, View view, int i, long l) {
                                // Según que usuario se seleccione se guarda en la variable @mSelectedUser
                                mSelectedUser = mUsers[i];
                                // De forma oculta se consigue la ID perteneciente a ese usuario
                                String[] aux = getAllIdForSpinner();
                                mSelectedId = aux[i];
                            }

                            @Override
                            public void onNothingSelected(AdapterView<?> adapterView) {

                            }
                        });
                        //Configurar el botón de descartar mensaje
                        //Botón de descarte
                        Button dismissButton = (Button) dialog.findViewById(R.id.Confirmar_seleccion_usuario);
                        //Proporcionar al botón un listener de OnClick
                        dismissButton.setOnClickListener(new View.OnClickListener() {
                            @Override
                            public void onClick(View view) {
                                //Cerrar el dialogo
                                dialog.dismiss();
                                /** Establecer la interfaz de usuario **/
                                mUserInterface.setVisibility(View.VISIBLE);
                                mStartActivity.setEnabled(true);
                                /** Configuración del reto diario del usuario**/
                                //Conseguir el dia de hoy en formato dd:MM
                                String aux = String.valueOf(mCalendar.get(Calendar.DAY_OF_MONTH)) + ":" + String.valueOf(mCalendar.get(Calendar.MONTH) + 1);
                                mToday = aux;
                                //Conseguir el lastlog del usuario guardado en la db
                                String aux2 = getSpecifiedUserlastLog(mSelectedId);
                                mYesterday = aux2;
                                //Comprobar que son días diferentes
                                boolean aux3 = checkForANewDay(aux, aux2);
                                //Conseguir un reto para el usuario si @aux3 == true
                                GiveMeAChallenge(aux3);
                                //Conseguir el reto de hoy del usuario
                                mTodaysChallenge = getSpecifiedUserChallenge(mSelectedId);
                                //Switch para clasificar los diferentes retos
                                switch (mTodaysChallenge) {
                                    case 1:
                                        //Comprobar si el usuario ha completado ya su reto diario
                                        if (getSpecifiedUserCompleted(mSelectedId) == 1) {
                                            //Cambiar el icono a reto completado e inhabilitando el mismo
                                            mChallengeButton.setBackgroundResource(R.drawable.challenge_completed);
                                            mChallengeButton.setEnabled(false);
                                        } else {
                                            //Si no lo ha completado, le asignamos el mensaje de primer reto
                                            isAfirstChallenge();
                                        }
                                        break;
                                    case 2:
                                        //Comprobar si el usuario ha completado ya su reto diario
                                        if (getSpecifiedUserCompleted(mSelectedId) == 1) {
                                            //Cambiar el icono a reto completado e inhabilitando el mismo
                                            mChallengeButton.setBackgroundResource(R.drawable.challenge_completed);
                                            mChallengeButton.setEnabled(false);
                                        } else {
                                            //Si no lo ha completado, le asignamos el mensaje de segundo reto
                                            isSecondChallenge();
                                        }
                                        break;
                                    case 3:
                                        //Comprobar si el usuario ha completado ya su reto diario
                                        if (getSpecifiedUserCompleted(mSelectedId) == 1) {
                                            //Cambiar el icono a reto completado e inhabilitando el mismo
                                            mChallengeButton.setBackgroundResource(R.drawable.challenge_completed);
                                            mChallengeButton.setEnabled(false);
                                        } else {
                                            //Si no lo ha completado, le asignamos el mensaje de tercerreto
                                            isThirdChallenge();
                                        }
                                        break;
                                    default:
                                        //En caso de no encontrar reto, se envía un error a la consola
                                        //(Imposible de ver por el usuario si no esta en debug mode
                                        Log.i("Error", "No challenge found");
                                        break;
                                }
                                //Designación del titulo de la interfaz de usuario
                                String placeholder = getString(R.string.titleUI) + " " + mSelectedUser;
                                mTitleUserInterface.setText(placeholder);
                                //Activar y desactivar los botones pertenecientes a la interfaz de usuario y de escaneo
                                mUserRecapButton.setEnabled(true);
                                mUserConfigButton.setEnabled(true);
                                mDeleteButton.setEnabled(true);
                                mListView.setEnabled(false);
                                mScanButton.setEnabled(false);
                            }
                        });

                        dialog.show();
                    }
                }
            });
        }
    }

    /**
     * Método que sirve como listener de click para el botón de escaneo
     * @param view El botón que ha sido clicado
     */
    public void scanbtDevices(View view){
        //Comienza el escaneo de dispositivos
        startScan();
    }

    /**
     * Este método trocea el values devuelto por el BLE con los datos del dispositivo a conectar
     * y lo asigna a diferentes variables usadas por la base de datos.
     * @param string Values del dispositivo
     */
    public void assignDeviceValues (String string){
        //Se abre interacción con la base de datos
        datos.getDb().beginTransaction();
        //Se separa cada dato por comas
        firstArray = string.split(",");
        //Se vuelve a separar por iguales
        secondArray = firstArray[positionDeviceName(firstArray)].split("=");
        //Consigue el nombre de sensortag], asi que nos quedamos con la palabra menos con el [
        mDeviceName = secondArray[1].substring(0, (secondArray[1].length() - 1));
        //Asignar valor a la variable @mGivenName
        mGivenName = getString(R.string.DeviceNameDefault);

        /** Conseguir ServiceUUID **/
        thirdArray = firstArray[positionmServiceUuids(firstArray)].split("=");
        // Consigue los service UUID quitando las llaves
        if(thirdArray[1].equals("null")){
            //Si el propio dispositivo no tiene UUID se le asignará uno random
            mServiceUUID = "DV-" + UUID.randomUUID().toString();
        }else {
            mServiceUUID = thirdArray[1].substring(1, (thirdArray[1].length() - 1));
        }
        // El beacon del dispositivo se puede conseguir de forma autonoma
        mDevice = mbtDevice.toString();

        // Se inserta en la base de datos el nuevo dispositivo
            datos.insertarDatosDispositivo(new DatosDispositivo(mDevice, mServiceUUID,
                    mDeviceName, mGivenName));
        // Se cierra la transacción con la base de datos
        try {
            //Si no se procesa el setTransactionSuccessful no se guardarán los cambios en la db
            datos.getDb().setTransactionSuccessful();
        }finally {
            datos.getDb().endTransaction();
        }
    }

    /**
     * Este método recoge los datos de un dispositivo existente y los vuelva en las mismas
     * variables que se usuarian en caso de que fuese nuevo
     * @param string Beacon del dispositivo (mDevice)
     */
    public void extractValues(String string){
        //Comenzar transacción con la base de datos
        datos.getDb().beginTransaction();
        //Abrir un cursor para los datos del a db
        Cursor aux = datos.obtenerDatosPorIdDispositivo(string);
        //El nombre del dispositivo se puede obtener de forma autonoma
        mDevice = mbtDevice.toString();
        //Conseguir el UUID asignado a ese dispositivo mediante el cursor
        mServiceUUID = getmServiceUUID(aux);
        //Conseguir el nombre de dispositivo asignado mediante el cursor
        mDeviceName = getmDeviceName(aux);
        //Conseguir el nombre dado al dispositivo mediante el cursor
        mGivenName = getGivenName(aux);
        //Cerrar el cursor
        aux.close();
        // Se cierra la transacción con la base de datos
        try {
            //Si no se procesa el setTransactionSuccessful no se guardarán los cambios en la db
            datos.getDb().setTransactionSuccessful();
        }finally {
            datos.getDb().endTransaction();
        }

    }

    /**
     * Método auxiliar utilizado para averiguar en que posición de un array de String se encuentra
     * la palabra "mDeviceName"
     * @param information Array String empleado en @assignDeviceValues para separar los values mediante comas
     * @return la posición en el array de la palabra mediante un int
     */
    public int positionDeviceName(String information[]){
        //Creación de un array auxiliar y del contador
        String stringaux[];
        int cont = 0;
        //Mediante un bucle for se buscará la palabra designada
        for (int i = 0; i<information.length; i++){
            //Se vuelve a separar el array para conseguir el nombre
            stringaux = information[i].split("=");
            //Si es la palabra que se busca, se cierra el bucle
            if (stringaux[0].equals("mDeviceName")) break;
            else cont++;
        }
        //Parámetro devuelto con -1 porque el cont++ se ejecuta una vez más de lo necesário
        return cont - 1;
    }

    /**
     * Método auxiliar empleado para conseguir la posición en un array String de la palabra "mServiceUUids"
     * @param information Array String empleado en @assignDeviceValues para separar los values mediante comas
     * @return la posición en el array de la palabra mediante un int
     */
    public int positionmServiceUuids(String information[]){
        //Creación de un array auxiliar y del contador
        String stringaux[];
        int cont = 0;
        //Mediante un bucle for se buscará la palabra designada
        for (int i = 0; i<information.length; i++){
            //Se vuelve a separar el array para conseguir el nombre
            stringaux = information[i].split("=");
            //Si es la palabra que se busca, se cierra el bucle. Se le añade un espacio, debido a que asi aparece en el values origianl
            if (stringaux[0].equals(" mServiceUuids")) break;
            else cont++;
        }
        //Se devuelve el contador sin offset.
        return cont;
    }

    /**
     *  Método para conseguir el nombre dado por el usuario al dispositivo
     *  Solo funciona con el método de conseguir datos dispositivo por ID
     */

    public String getGivenName(Cursor cursor){
        //Creación de variable auxiliar String para guardar la palabra
        String aux40 = "";
        //Si el cursor existe
        if (cursor.moveToFirst()){
            do{
                //Se le asigna a la variable @aux40 el valor de la columna GIVENNAME de la tabla Usuarios
                aux40 = cursor.getString(cursor.getColumnIndex(DeviceContract.DatosDispositivos.GIVENNAME));
            }while(cursor.moveToNext());
        }
        return aux40;
    }
    /**
     *  Método para conseguir el ServiceUUID del dispositivo
     *  Solo funciona con el método de conseguir datos dispositivo por ID
     */
    public String getmServiceUUID(Cursor cursor){

        String aux40 = "";
        if (cursor.moveToFirst()){
            do{
                aux40 = cursor.getString(cursor.getColumnIndex(DeviceContract.DatosDispositivos.MSERVICEUUID));
                // do what ever you want here
            }while(cursor.moveToNext());
        }
        //cursor.close();
        return aux40;
    }
    /**
     *  Método para conseguir el nombre del propio dispositivo
     *  Solo funciona con el método de conseguir datos dispositivo por ID
     */
    public String getmDeviceName(Cursor cursor){

        String aux40 = "";
        if (cursor.moveToFirst()){
            do{
                aux40 = cursor.getString(cursor.getColumnIndex(DeviceContract.DatosDispositivos.MDEVICENAME));
                // do what ever you want here
            }while(cursor.moveToNext());
        }
        //cursor.close();
        return aux40;
    }

    /**
     * Método auxiliar utilizado en el escaneo para saber si ya esta registrado el dispositivo en la
     * bd
     * @param mDevice Beacon del dispositivo encontrado en el escaneo
     * @return boolean true/false si existe o no existe
     */
    public boolean doDeviceExist(String mDevice){
        // Se obtiene un cursor con todos los dispositivos, un auxiliar String y el boolean a devolver
        Cursor cursor = datos.obtenerDatosDispositivo();
        String aux;
        boolean bool = false;
        //Si el cursor existe
        if(cursor.moveToFirst()){
            do{
                //Asigna al valor aux, el valor encontrado en la columna MDEVICE de la tabla DATOSDISPOSITIVO de la db
                aux = cursor.getString(cursor.getColumnIndex(DeviceContract.DatosDispositivos.MDEVICE));
                //Comparar si el valor pasado a la función equivale al aux. Si es asi, el valor del bool pasará a true
                if(aux.equals(mDevice)) bool = true;
            }while (cursor.moveToNext()); //Seguir iterando hasta que el cursor llegue al final
        }
        //Cerrar el cursor
        cursor.close();
        //Devolver el boolean
        return bool;
    }

    /**
     * Método auxiliar utilizado para conseguir un array de String empleado para la creación de
     * desplegables.
     * @return array de String conteniendo todos los dispositivos de la bd
     */
    public String[] getAllExistentDevicesforSpinner(){
        //Se crea un array String tan grande como la variable count inicializada en @OnCreate
        String[] res = new String[howManyDevices];
        int count = 0;
        //Se abre un cursor para leer los datos de los Dispositivos
        Cursor cursor = datos.obtenerDatosDispositivo();
        //Si el cursor existe
        if(cursor.moveToFirst()){
            do{
                //Asigna a la posición del array count el valor encontrado en la columna MDEVICE de la tabla DATOSDISPOSITIVO
                res[count] = cursor.getString(cursor.getColumnIndex(DeviceContract.DatosDispositivos.MDEVICE));
                //Aumentamos el count
                count++;
            }while ( cursor.moveToNext()); //Continua iterando hasta que el cursor se quede sin datos
        }
        //Devuelve el array
        return res;
    }

    /**
     * Método auxiliar utilizado en @OnCreate para incrementar un count que mide
     * cuantos dispositivos hay registrados en la base de datos.
     */

    public void calculateHowManyDevices (){
        Cursor cursor = datos.obtenerDatosDispositivo();
        if(cursor.moveToFirst()){
            do{
                howManyDevices++;
            }while(cursor.moveToNext());
        }

        cursor.close();
    }

    /**
     *  [/Cosas de Dispostitivo]
     *  [Cosas de Usuario]
     *  El siguiente método consigue todos los usuarios registrados en la DB (con un límite
     *  de 5) y los comunica mediante un String Array
      */

    public String[] getAllExistentUsers(){
        Cursor cursor = datos.obtenerUsuarios();
        String aux, aux1 = getString(R.string.newUserString);
        String[] Users = {aux1,aux1,aux1,aux1,aux1};
        int count = Users.length -1;
        if(cursor.moveToFirst()){
            do{
                aux = cursor.getString(cursor.getColumnIndex(DeviceContract.Usuarios.NOMBRE));
                Users[count] = aux;
                count--;
            }while (cursor.moveToNext());
        }
        cursor.close();
        return Users;
    }

    /**
     * Método auxiliar utilizado en @OnCreate para incrementar un count que mide
     * cuantos usuarios hay registrados en la base de datos.
     */

    public void calculateHowManyUsers(){
        Cursor cursor = datos.obtenerUsuarios();

        if(cursor.moveToFirst()){
            do{
                howManyUsers++;
            }while(cursor.moveToNext());
        }
        cursor.close();
    }

    /**
     * Método auxiliar utilizado para conseguir un array de String empleado para la creación de
     * desplegables.
     * @return array de String conteniendo todos los usuarios de la bd
     */

    public String[] getAllExistentUsersforSpinner(){
        //Se llama al método @getAllExistentUsers
        String[] aux = getAllExistentUsers();
        //Se crea una variable auxiliar del mismo tamaño que el número de usuarios registrados
        String[] res = new String[howManyUsers];
        //Bucle for que vuelve del reves el primer String para mostrar los usuarios en orden inverso
        for(int i = 0; i < aux.length; i++){
            if (aux[(aux.length-1)-i].equals(getString(R.string.newUserString)));
            else res[i] = aux[((aux.length)-1)-i];
        }

        return res;
    }

    /**
     * El siguiente método devuelve un nombre de usuario específico mediante la ID de dicho usuario
     * @param id del usuario a buscar
     * @return nombre del usuario
     */
    public String getSpecifiedUserforId(String id){
        Cursor cursor = datos.obtenerUsuarioPorId(id);
        String res="";

        if(cursor.moveToFirst()){
            do{
                res = cursor.getString(cursor.getColumnIndex(DeviceContract.Usuarios.NOMBRE));
            }while (cursor.moveToNext());
        }
        cursor.close();
        return res;
    }

    /**
     * El método que hay a continuación consigue todos los id de usuarios registrados en la DB
     * (Con un límite de 5) y los comunica con un StringArray.
     */
    public String[] getAllIdfromExistentUsers(){
        Cursor cursor = datos.obtenerUsuarios();
        String aux, aux1 = getString(R.string.newUserIdString);
        String[] id = {aux1,aux1,aux1,aux1,aux1};
        int count = id.length -1;
        if(cursor.moveToFirst()){
            do{
                aux = cursor.getString(cursor.getColumnIndex(DeviceContract.Usuarios.ID));
                id[count] = aux;
                if (!id[count].equals(aux1)) howMuchIds++;
                count--;
            }while (cursor.moveToNext());
        }
        cursor.close();
        return id;
    }

    /**
     * Método auxiliar utilizado para conseguir las ID en el mismo orden que el usuario,
     * preparadas de tal forma que pueden ponerse en un desplegable.
     * @return String array con todas las IDs
     */
    public String[] getAllIdForSpinner(){
        String[] res = new String[5];
        Cursor cursor = datos.obtenerUsuarios();
        String aux;
        int count = 0;
        if (cursor.moveToFirst()) {
            do{
                aux = cursor.getString(cursor.getColumnIndex(DeviceContract.Usuarios.ID));
                res[count] = aux;
                count++;
            }while(cursor.moveToNext());
        }
        cursor.close();
        return res;
    }

    /**
     * El siguiente método consigue la altura del usuario especificado
     */

    public String getSpecifiedUserHeight(String id){
        Cursor cursor = datos.obtenerUsuarioPorId(id);
        String res="";

        if(cursor.moveToFirst()){
            do{
                res = cursor.getString(cursor.getColumnIndex(DeviceContract.Usuarios.ALTURA));
            }while (cursor.moveToNext());
        }
        cursor.close();
        return res;
    }

    /**
     * El siguiente método consigue la información de si el usuario especificado a completado
     * el reto diario
     * @param id del Usuario a buscar
     * @return int que es 0 para no completado y 1 para completado
     */

    public int getSpecifiedUserCompleted(String id){
        Cursor cursor = datos.obtenerUsuarioPorId(id);
        int res = 0;

        if(cursor.moveToFirst()){
            do{
                res = cursor.getInt(cursor.getColumnIndex(DeviceContract.Usuarios.RETOCOMPLTADO));
            }while (cursor.moveToNext());
        }
        cursor.close();
        return res;
    }

    /**
     * El siguiente método devuelve el peso de un Usuario específicado
     * @param id del Usuario a buscar
     * @return peso del usuario
     */

    public String getSpecifiedUserWeight(String id){
        Cursor cursor = datos.obtenerUsuarioPorId(id);
        String res = "";

        if(cursor.moveToFirst()){
            do{
                res = cursor.getString(cursor.getColumnIndex(DeviceContract.Usuarios.PESO));
            }while(cursor.moveToNext());
        }
        cursor.close();
        return res;
    }

    /**
     * El siguiente método devuelve la zancada del usuario especificado
     * @param id del Usuario a buscar
     * @return zancada del usuario
     */

    public String getSpecifiedZancada(String id){
        Cursor cursor = datos.obtenerUsuarioPorId(id);
        String res = "";

        if(cursor.moveToFirst()){
            do{
                res = cursor.getString(cursor.getColumnIndex(DeviceContract.Usuarios.ZANCADA));
            }while (cursor.moveToNext());
        }
        cursor.close();
        return res;
    }

    /**
     * El siguiente método devuelve el reto diario del usuario especificado
     * @param id del Usuario a buscar
     * @return int que es 1, para reto uno; 2, para reto dos y 3, para reto tres
     */

    public int getSpecifiedUserChallenge(String id){
        Cursor cursor = datos.obtenerUsuarioPorId(id);
        int res = 0;
        if(cursor.moveToFirst()){
            do{
                res = cursor.getInt(cursor.getColumnIndex(DeviceContract.Usuarios.RETODIARIO));
            }while (cursor.moveToNext());
        }
        cursor.close();
        return res;
    }

    /**
     * El siguiente método devuelve el código de la ultima fecha de log del Usuario en base:
     * DD:MM
     * @param id del Usuario a buscar
     * @return lastlog del usuario especificado
     */

    public String getSpecifiedUserlastLog(String id){
        Cursor cursor = datos.obtenerUsuarioPorId(id);
        String res = "";
        if(cursor.moveToFirst()){
            do{
                res = cursor.getString(cursor.getColumnIndex(DeviceContract.Usuarios.LASTLOG));
            }while (cursor.moveToNext());
        }
        cursor.close();
        return res;
    }

    /**
     * [/Usuario]
     * [Rendimiento]
     * Este método devuelve las fechas para la fecha de hoy, máximo 5 entradas
     */

    public String[] getLastPerformanceDates(){
        Cursor cursor = datos.obtenerRendimientosUsuario();
        String[] fechas = new String[5];
        int count = 0;
        if(cursor.moveToFirst()){
            do{
                if (count <= 4) {
                    fechas[count] = cursor.getString(cursor.getColumnIndex(DeviceContract.RendimientoUsuarios.FECHA));
                    count++;
                }
            }while(cursor.moveToNext());
        }
        cursor.close();
        return fechas;
    }

    /**
     * El siguiente método devuelve los kilometros por la fecha marcada
     */

    public double getSpecifiedPerformanceDistance(String fecha){
        Cursor cursor = datos.obtenerRendimientoPorFecha(fecha);
        double res = 0;
        if(cursor.moveToFirst()){
            do{
                res = cursor.getDouble(cursor.getColumnIndex(DeviceContract.RendimientoUsuarios.DISTANCIA));
            }while (cursor.moveToNext());
        }
        cursor.close();
        return res;
    }

    /**
     * El siguiente método devuelve las calorias quemadas por la fecha marcada
     */

    public double getSpecifiedBurnedCalories(String fecha){
        Cursor cursor = datos.obtenerRendimientoPorFecha(fecha);
        double res = 0;
        if(cursor.moveToFirst()){
            do {
                res = cursor.getDouble(cursor.getColumnIndex(DeviceContract.RendimientoUsuarios.CALORIAS_QUEMADAS));
            }while (cursor.moveToNext());
        }
        cursor.close();
        return res;
    }

    /**
     * Método que devuelve todos los pasos dados para un usuario especifico
     * @return int pasos totales dados por el usuario en todas las actividades
     */
    public int getAllCurrentSteps(){
        //Se abre un cursor con los rendimientos de todos los usuarios
        Cursor cursor = datos.obtenerRendimientosUsuario();
        //Se inicializa un int que nos servirá como contador de pasos
        int totalsteps = 0;
        //Si el cursor existe...
        if(cursor.moveToFirst()){
            do{
                //Comprueba que el usuario seleccionado previamente coincide con el nombre de usuario de esta actividad
                if(mSelectedUser.equals(cursor.getString(cursor.getColumnIndex(DeviceContract.RendimientoUsuarios.NOMBRE))))
                    //Si es asi, asigna el valor a totalsteps sumandole los que ya se hayan contado
                totalsteps = totalsteps + cursor.getInt(cursor.getColumnIndex(DeviceContract.RendimientoUsuarios.PASOS));
            }while (cursor.moveToNext()); //Sigue iterando hasta que no haya más datos
        }
        //Cierra el cursor
        cursor.close();
        //Devuelve el número total de pasos
        return totalsteps;
    }

    /**
     * Método auxiliar que devuelve el número de malos pasos totales dados por un usuario especificado
     * @return número total de pasos dados por el usuario
     */
    public int getAllCurrentBadSteps(){
        Cursor cursor = datos.obtenerRendimientosUsuario();
        int totalbadsteps = 0;
        if(cursor.moveToFirst()){
            do{
                if(mSelectedUser.equals(cursor.getString(cursor.getColumnIndex(DeviceContract.RendimientoUsuarios.NOMBRE))))
                totalbadsteps = totalbadsteps + cursor.getInt(cursor.getColumnIndex(DeviceContract.RendimientoUsuarios.PASOS_MALOS));
            }while (cursor.moveToNext());
        }
        cursor.close();
        return totalbadsteps;
    }

    /**
     * Método auxiliar que devuelve el número de pasos realizados con el talón por un usuario
     * especificado
     * @return número total de pasos realizados de talón
     */
    public int getAllCurrentBadSteps2(){
        Cursor cursor = datos.obtenerRendimientosUsuario();
        int totalbadsteps2 = 0;
        if(cursor.moveToFirst()){
            do{
                if(mSelectedUser.equals(cursor.getString(cursor.getColumnIndex(DeviceContract.RendimientoUsuarios.NOMBRE))))
                    totalbadsteps2 =  totalbadsteps2 + cursor.getInt(cursor.getColumnIndex(DeviceContract.RendimientoUsuarios.PASOS_MALOS_2));
            }while(cursor.moveToNext());
        }
        cursor.close();
        return totalbadsteps2;
    }

    /**
     * Método auxiliar que devuelve el número de pasos pesados totales dados por un usuario especificado
     * @return número total de pasos pesados dados por el usuario
     */
    public int getAllCurrentHeavySteps(){
        Cursor cursor = datos.obtenerRendimientosUsuario();
        int totalheavysteps = 0;
        if(cursor.moveToFirst()){
            do{
                if(mSelectedUser.equals(cursor.getString(cursor.getColumnIndex(DeviceContract.RendimientoUsuarios.NOMBRE))))
                totalheavysteps = totalheavysteps + cursor.getInt(cursor.getColumnIndex(DeviceContract.RendimientoUsuarios.PASOS_PESADOS));
            }while (cursor.moveToNext());
        }
        cursor.close();
        return totalheavysteps;
    }

    /**
     * Método auxiliar que devuelve la distancia total del recorrido que ha hecho el usuario
     * @return distancia total recorrida por el usuario
     */
    public double getAllCurrentDistance(){
        Cursor cursor = datos.obtenerRendimientosUsuario();
        double totaldistance = 0;
        if(cursor.moveToFirst()){
            do{
                if(mSelectedUser.equals(cursor.getString(cursor.getColumnIndex(DeviceContract.RendimientoUsuarios.NOMBRE))))
                totaldistance = totaldistance + cursor.getDouble(cursor.getColumnIndex(DeviceContract.RendimientoUsuarios.DISTANCIA));
            }while (cursor.moveToNext());
        }
        cursor.close();
        return totaldistance;
    }

    /**
     * Método auxiliar que devuelve el total de calorias quemadas por el usuario en todas las actividades
     * @return número total de calorías quemadas
     */
    public double getAllBurnedCalories(){
        Cursor cursor = datos.obtenerRendimientosUsuario();
        double totalcalories = 0;
        if(cursor.moveToFirst()){
            do{
                if(mSelectedUser.equals(cursor.getString(cursor.getColumnIndex(DeviceContract.RendimientoUsuarios.NOMBRE))))
                    totalcalories = totalcalories + cursor.getDouble(cursor.getColumnIndex(DeviceContract.RendimientoUsuarios.CALORIAS_QUEMADAS));
            }while (cursor.moveToNext());
        }
        cursor.close();
        return totalcalories;
    }

    /**
     * Este método consigue todas las calorías quemadas en una fecha concreta
     * @param fecha fecha a consultar
     * @return suma total de calorías
     */
    public double getAllBurnedCaloriesForToday(String fecha){
        //Incialización del cursor para obtener los rendimientos
        Cursor cursor = datos.obtenerRendimientosUsuario();
        //Consigue las última fechas
        String aux[] = getLastPerformanceDates();
        //Separa las fechas por guiones
        String aux1[] = fecha.split("-");
        //Inicialización de el contador de calorías y la creación de un String auxiliar para contener la fecha
        String aux2[];
        double burnedcalories = 0;
        //Iterador for para conseguir todas las calorías
        for (int i = 0; i < aux.length; i++){
            //Si existe al menos una fecha...
            if(aux[i]!= null){
                //Si el cursor existe...
                if(cursor.moveToFirst()){
                    do{
                        //Separa la fecha otra vez
                        aux2 = aux[i].split("-");
                        //Si las fechas equivalen...
                        if(aux2[0].equals(aux1[0])){
                            //Suma las calorías al montón
                            burnedcalories = burnedcalories + cursor.getDouble(cursor.getColumnIndex(DeviceContract.RendimientoUsuarios.CALORIAS_QUEMADAS));
                        }
                }while(cursor.moveToNext()); //Continua iterando hasta que no quede ningun dato

                }
            }
        }
        //Devuelve la suma total de calorías
        return  burnedcalories;
    }

    /**
     * Método que consigue toda la distancia recorrida en un día concreto
     * @param fecha a buscar
     * @return suma total de la distancia
     */
    public double getAllDistanceForToday(String fecha){
        Cursor cursor = datos.obtenerRendimientosUsuario();
        String aux[] = getLastPerformanceDates();
        String aux1[] = fecha.split("-");
        String aux2[];
        double distance = 0;
        for (int i = 0; i < aux.length; i++){
            if(aux[i]!= null){
                if(cursor.moveToFirst()){
                    do{
                        aux2 = aux[i].split("-");
                        if(aux2[0].equals(aux1[0])){
                            distance = distance + cursor.getDouble(cursor.getColumnIndex(DeviceContract.RendimientoUsuarios.DISTANCIA));
                        }
                    }while(cursor.moveToNext());


                }
            }
        }
        return  distance;
    }

    /** Métodos de BLE **/
    /** Variables de BLE **/
       /* Gyroscope Service */
        private static final UUID GYROSCOPE_SERVICE = UUID.fromString("f000aa50-0451-4000-b000-000000000000");
        private static final UUID GYROSCOPE_DATA_CHAR = UUID.fromString("f000aa51-0451-4000-b000-000000000000");
        private static final UUID GYROSCOPE_CONFIG_CHAR = UUID.fromString("f000aa52-0451-4000-b000-000000000000");
        private static final UUID GYROSCOPE_PERIOD_CONFIG = UUID.fromString("f000aa53-0451-4000-b000-000000000000");
        /* Accelerometer Service */
        private static final UUID ACCELEROMETER_SERVICE = UUID.fromString("f000aa10-0451-4000-b000-000000000000");
        private static final UUID ACCELEROMETER_DATA_CHAR = UUID.fromString("f000aa11-0451-4000-b000-000000000000");
        private static final UUID ACCELEROMETER_CONFIG_CHAR = UUID.fromString("f000aa12-0451-4000-b000-000000000000");
        private static final UUID ACCELEROMETER_PERIOD_CONFIG = UUID.fromString("f000aa13-0451-4000-b000-000000000000");

        //Client Configuration Descriptor
        public static final UUID CONFIG_DESCRIPTOR = UUID.fromString("00002902-0000-1000-8000-00805f9b34fb");
    /** MENSAJES **/
        //GYROSCOPE
            private static final int MSG_GYRO = 101;
        //ACELROMETER
            private static final int MSG_ACC = 102;
        //GENERAL
            private static final int MSG_PROGRESS = 201;
            private static final int MSG_DISMISS = 202;
            private static final int MSG_CLEAR = 203;

    private BluetoothAdapter mBluetoothAdapter;
    private BluetoothGatt mConnectedGatt;
    private ProgressDialog mProgress;

    /**
     * Méotod que activa el escaneo de dispositivos BLE
     * @param enable activar / desactivar el escaneo
     */
    private void scanLeDevice(final boolean enable) {
        if (enable) {
            mHandler.postDelayed(new Runnable() {
                @Override
                public void run() {
                    if (Build.VERSION.SDK_INT < 21) {
                        mBluetoothAdapter.stopLeScan(mLeScanCallback);
                    } else {
                        mLEScanner.stopScan(mScanCallback);

                    }
                }
            }, SCAN_PERIOD);
            if (Build.VERSION.SDK_INT < 21) {
                mBluetoothAdapter.startLeScan(mLeScanCallback);
            } else {
                mLEScanner.startScan(filters, settings, mScanCallback);
            }
        } else {
            if (Build.VERSION.SDK_INT < 21) {
                mBluetoothAdapter.stopLeScan(mLeScanCallback);
            } else {
                mLEScanner.stopScan(mScanCallback);
            }
        }
    }


    private ScanCallback mScanCallback = new ScanCallback() {
        @Override
        public void onScanResult(int callbackType, ScanResult result) {
            mbtDevice = result.getDevice();
            mScanResult = result.getScanRecord().toString();
            connectToDevice(mbtDevice);
            //Conseguir boolean deviceexist
            Log.i("Existe el dispositivo?=", String.valueOf(doDeviceExist(mbtDevice.toString())));
            if(doDeviceExist(mbtDevice.toString())){
                extractValues(mbtDevice.toString());
            }else {
                assignDeviceValues(mScanResult);
            }
        }

        @Override
        public void onBatchScanResults(List<ScanResult> results) {
            for (ScanResult sr : results) {
                Log.i("ScanResult - Results", sr.toString());
            }
        }

        @Override
        public void onScanFailed(int errorCode) {
            Log.e("Scan Failed", "Error Code: " + errorCode);
        }
    };

    private BluetoothAdapter.LeScanCallback mLeScanCallback =
            new BluetoothAdapter.LeScanCallback() {
                @Override
                public void onLeScan(final BluetoothDevice device, int rssi,
                                     byte[] scanRecord) {
                    Log.i(TAG, "New LE Device: " + device.getName() + " @ " + rssi);
                    runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            Log.i("onLeScan", device.toString());
                            connectToDevice(device);
                        }
                    });
                }
            };

    public void connectToDevice(BluetoothDevice device) {
        if (mGatt == null) {
            mGatt = device.connectGatt(this, false, gattCallback);
            scanLeDevice(false);// will stop after first device detection
        }
    }

    /**
     * En este método de llamada, se ha creado una máquina de estados para forzar
     * que tan solo una característica del dispositivo sea leida o escribida a la
     * vez, hasta que todos los sensores esten activados y registrados.
     */
    private final BluetoothGattCallback gattCallback = new BluetoothGattCallback() {

        private int mState = 0;
        private void reset(){mState = 0;}
        private void advance(){mState++;}
        /*
         * Manda un comando de encendido a cada sensor escribiendo la llave de
         * la configuración de la característica. Esto es especifico del
         * sensortag, ya que asi permite un consumo menor de energia desactivando
         * los snesores que no esten usandose.
         */
        private void enableNextSensor(BluetoothGatt gatt){
            BluetoothGattCharacteristic characteristic;
            switch (mState){
                case 0:
                    Log.d(TAG, "Enabling Gyroscope");
                    characteristic = gatt.getService(GYROSCOPE_SERVICE)
                            .getCharacteristic(GYROSCOPE_CONFIG_CHAR);
                    characteristic.setValue(new byte[]{7});
                    break;
                case 1:
                    Log.d(TAG, "Enabling gyroscope period");
                    characteristic = gatt.getService(GYROSCOPE_SERVICE)
                            .getCharacteristic(GYROSCOPE_PERIOD_CONFIG);
                    characteristic.setValue(new byte[]{0x0A});
                    break;
                case 2:
                    Log.d(TAG, "Enabling Accelerometer");
                    characteristic = gatt.getService(ACCELEROMETER_SERVICE)
                            .getCharacteristic(ACCELEROMETER_CONFIG_CHAR);
                    characteristic.setValue(new byte[]{0x01});
                    break;
                case 3:
                    Log.d(TAG, "Enabling accelerometer period");
                    characteristic = gatt.getService(ACCELEROMETER_SERVICE)
                            .getCharacteristic(ACCELEROMETER_PERIOD_CONFIG);
                    characteristic.setValue(new byte[]{0x0A});
                    break;
                default:
                    mHandler.sendEmptyMessage(MSG_DISMISS);
                    Log.i(TAG, "All Sensors Enabled");
                    return;
            }
            gatt.writeCharacteristic(characteristic);
        }

        /*
        * Lee los datos de caracteristica para cada sensor
        */
        private void readNextSensor(BluetoothGatt gatt){
            BluetoothGattCharacteristic characteristic;
            switch (mState){
                case 0:
                    Log.d(TAG, "Reading gyroscope");
                    characteristic = gatt.getService(GYROSCOPE_SERVICE)
                            .getCharacteristic(GYROSCOPE_DATA_CHAR);
                    break;
                case 1:
                    Log.d(TAG, "Reading accelerometer");
                    characteristic = gatt.getService(ACCELEROMETER_SERVICE)
                            .getCharacteristic(ACCELEROMETER_DATA_CHAR);
                    break;
                default:
                    mHandler.sendEmptyMessage(MSG_DISMISS);
                    Log.i(TAG, "All Sensors Enabled");
                    return;
            }
            gatt.readCharacteristic(characteristic);
        }
        /*
        * Activa la notificación de cambios en datos de cada caracteristica en cada sensor
        * esribiendo ENABLE_NOTIFICATION_VALUE la configuración de cada característica.
        */
        private void setNotifyNextSensor(BluetoothGatt gatt){
            BluetoothGattCharacteristic characteristic;
            switch (mState){
                case 0:
                    Log.d(TAG, "Set notify Gyroscope");
                    characteristic = gatt.getService(GYROSCOPE_SERVICE)
                            .getCharacteristic(GYROSCOPE_DATA_CHAR);
                    break;
                case 1:
                    Log.d(TAG, "Set notify Accelerometer");
                    characteristic = gatt.getService(ACCELEROMETER_SERVICE)
                            .getCharacteristic(ACCELEROMETER_DATA_CHAR);
                    break;
                default:
                    mHandler.sendEmptyMessage(MSG_DISMISS);
                    Log.i(TAG, "All Sensors Enabled");
                    return;
            }
            //Permitir notificaciones locales
            gatt.setCharacteristicNotification(characteristic, true);
            //Permitir notificaciones remotas
            BluetoothGattDescriptor desc = characteristic.getDescriptor(CONFIG_DESCRIPTOR);
            desc.setValue(BluetoothGattDescriptor.ENABLE_NOTIFICATION_VALUE);
            gatt.writeDescriptor(desc);
        }
        @Override
        public void onConnectionStateChange(BluetoothGatt gatt, int status, int newState) {
            Log.i("onConnectionStateChange", "Status: " + status);
            Log.d(TAG, "Connection State Change: " + status + " -> " + connectionState(newState));
            if (status == BluetoothGatt.GATT_SUCCESS && newState == BluetoothProfile.STATE_CONNECTED) {
                /**
                 * Una vez que nos conectamos con exito, debemos descrubir todos los servicios en el
                 * dispositivo antes de leer y escribir las características.
                 */
                gatt.discoverServices();
                mHandler.sendMessage(Message.obtain(null, MSG_PROGRESS, getString(R.string.mHandlerDiscoveringServices)));
                IsSensorStarted = false;
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {

                        if(!IsSensorStarted){
                            mostrarListView();
                            IsSensorStarted = true;
                        }

                    }
                });
            }else if(status == BluetoothGatt.GATT_SUCCESS && newState == BluetoothProfile.STATE_DISCONNECTED) {
                /**
                 * Si en algún punto nos desconectamos, enviamos un mensaje para limpiar los valores
                 */
                mHandler.sendEmptyMessage(MSG_CLEAR);
            }else if(status != BluetoothGatt.GATT_SUCCESS){
                /**
                 * Si hay cualquier fallo, desconecta
                 */
                gatt.disconnect();
            }

        }

        @Override
        public void onServicesDiscovered(BluetoothGatt gatt, int status) {
           Log.d(TAG, "Services Discovered: " + status);
            mHandler.sendMessage(Message.obtain(null, MSG_PROGRESS, getString(R.string.mHandlerEnablingSensors)));
            /**
             * Con los servicios descubiertos, reiniciamos la maquina de estados y comenzamos
             * a trabajar con los sensores que necesitan ser activados.
             */
            reset();
            enableNextSensor(gatt);

        }

        @Override
        public void onCharacteristicRead(BluetoothGatt gatt,
                                         BluetoothGattCharacteristic
                                                 characteristic, int status) {
           //Por cada vez que se lea un cambio, se pasa la información
            if(GYROSCOPE_DATA_CHAR.equals(characteristic.getUuid())){
                mHandler.sendMessage(Message.obtain(null, MSG_GYRO, characteristic));
            }
            if(ACCELEROMETER_DATA_CHAR.equals(characteristic.getUuid())){
                mHandler.sendMessage(Message.obtain(null, MSG_ACC, characteristic));
            }
            //Despues de leer los valores iniciales continuamos con el encendido
            setNotifyNextSensor(gatt);
        }

        @Override
        public void onCharacteristicWrite(BluetoothGatt gatt, BluetoothGattCharacteristic characteristic, int status) {
            //Despues de escribir el flag, leemos el siguiente sensor
            readNextSensor(gatt);
        }

        @Override
        public void onCharacteristicChanged(BluetoothGatt gatt, BluetoothGattCharacteristic characteristic){
            /**
             * Despues de que las notificaciones esten activiadas, todas las actualizaciones
             * de las características del dispositivo y sus cambios se mostrarán aqui.
             * Es similar al método de lectura, ya que devolvemos los datos de cambio.
             */
            if(GYROSCOPE_DATA_CHAR.equals(characteristic.getUuid())){
                mHandler.sendMessage(Message.obtain(null, MSG_GYRO, characteristic));
            }
            if (ACCELEROMETER_DATA_CHAR.equals(characteristic.getUuid())) {
                mHandler.sendMessage(Message.obtain(null, MSG_ACC, characteristic));
            }
        }
        @Override
        public void onDescriptorWrite(BluetoothGatt gatt, BluetoothGattDescriptor descriptor, int status) {
            //Una vez que las notificaciones esten activadas, nos movemos al siguiente sensor
            advance();
            enableNextSensor(gatt);
        }

        @Override
        public void onReadRemoteRssi(BluetoothGatt gatt, int rssi, int status) {
            Log.d(TAG, "Remote RSSI: "+rssi);
        }

        private String connectionState(int status) {
            switch (status) {
                case BluetoothProfile.STATE_CONNECTED:
                    return "Connected";
                case BluetoothProfile.STATE_DISCONNECTED:
                    return "Disconnected";
                case BluetoothProfile.STATE_CONNECTING:
                    return "Connecting";
                case BluetoothProfile.STATE_DISCONNECTING:
                    return "Disconnecting";
                default:
                    return String.valueOf(status);
            }
        }
    };

    @Override
    public void onRequestPermissionsResult(int requestCode,
                                           String permissions[], int[] grantResults) {
        switch (requestCode) {
            case PERMISSION_REQUEST_COARSE_LOCATION: {
                if (grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                    Log.d(TAG, "coarse location permission granted");
                } else {
                    final AlertDialog.Builder builder = new AlertDialog.Builder(this);
                    builder.setTitle(getString(R.string.onRequestPermissionRessultAlertDialogTitle));
                    builder.setMessage(getString(R.string.onRequestPermissionRessultAlertDialogDescription));
                    builder.setPositiveButton(android.R.string.ok, null);
                    builder.setOnDismissListener(new DialogInterface.OnDismissListener() {

                        @Override
                        public void onDismiss(DialogInterface dialog) {
                        }

                    });
                    builder.show();
                }
                return;
            }
        }
    }

    private Runnable mStopRunnable = new Runnable() {
        @Override
        public void run() {
            stopScan();
        }
    };
    private Runnable mStartRunnable = new Runnable() {
        @Override
        public void run() {
            startScan();
        }
    };
    private void startScan(){
        mScanButton.setBackgroundResource(R.drawable.ic_history_24dp);
        scanLeDevice(true);
        mScanButton.setEnabled(false);
        mHandler.postDelayed(mStopRunnable, 2500);
    }
    private void stopScan(){
        mScanButton.setBackgroundResource(R.drawable.ic_cached_24dp);
        scanLeDevice(false);
        mScanButton.setEnabled(true);
    }
    private Handler mHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            BluetoothGattCharacteristic characteristic;
            switch (msg.what) {
                case MSG_GYRO:
                    characteristic = (BluetoothGattCharacteristic)msg.obj;
                    if(characteristic.getValue() == null){
                        Log.w(TAG, "Error obtaining acc value");
                        return;
                    }
                    updateGyroData(characteristic);
                    break;
                case MSG_ACC:
                    characteristic = (BluetoothGattCharacteristic)msg.obj;
                    if (characteristic.getValue() == null){
                        Log.w(TAG, "Error obtaining acc value");
                        return;
                    }
                    updateAccData(characteristic);
                    break;
                case MSG_PROGRESS:
                    mProgress.setMessage((String) msg.obj);
                    if (!mProgress.isShowing()) {
                        mProgress.show();
                    }
                    break;
                case MSG_DISMISS:
                    mProgress.hide();
                    break;
                case MSG_CLEAR:
                    clearDisplayValues();
                    break;
            }
        }
    };


    /**
     * Método que recoge los cambios del acelerómetro y los asigna a unas variables y calcula los ángulos de inclinación.
     * Los conversores se encuentran en SensorTagData.class
     * @param characteristic característica a leer
     */
    private void updateAccData(BluetoothGattCharacteristic characteristic){

        byte[] value = characteristic.getValue();
        float[] resacc = SensorTagData.extractAccData(value);

        mAccX = (resacc[0]);
        mAccY = (resacc[1]);
        mAccZ = (resacc[2]);

        mInclinationAngle[0] = Math.atan(mAccX/Math.sqrt(Math.pow(mAccY,2) + Math.pow(mAccZ,2)))*(180.0/Math.PI);
        mInclinationAngle[1] = Math.atan(mAccY/Math.sqrt(Math.pow(mAccX,2) + Math.pow(mAccZ,2)))*(180.0/Math.PI);
    }

    /**
     * Método que recoge los cambios del giroscopio y los agina a unas variables.
     * Los conversores se encuentran en SensorTagData.class
     * @param characteristic característica a leer.
     */
    private void updateGyroData(BluetoothGattCharacteristic characteristic){
        float[] resgyro = SensorTagData.extractGyroData(characteristic);

        mGyroX = (resgyro[0]);
        mGyroY = (resgyro[1]);
        mGyroZ = (resgyro[2]);
    }

    /**
     * Método que setea los valores a 0 en caso de desconexión
     */
    public void clearDisplayValues(){
        mAccX = 0;
        mAccY = 0;
        mAccZ = 0;
        mGyroX = 0;
        mGyroY = 0;
        mGyroZ = 0;
    }

    /** Parte de Sensores del propio móvil **/
    // Variables
    private TextView sensorTextView, detectorTextView;
    private SensorManager mSensorManager;
    private Sensor mStepCounterSensor;
    private Sensor mStepDetectorSensor;

    /** Implementación de método onSensorChanged **/
    public void onSensorChanged(SensorEvent event){
        Sensor sensor = event.sensor;
        float[] values = event.values;
        float[] stepDetector;
        mCountSteps = -1;

        if (values.length > 0){
            if(!AndroidSensorBooted){
                mOffsetCountStep = (int) values[0];
                AndroidSensorBooted = true;
            }
            mCountSteps = (int) values[0] - mOffsetCountStep;

        }
        if (sensor.getType() == Sensor.TYPE_STEP_COUNTER) {
        }else if (sensor.getType() == Sensor.TYPE_STEP_DETECTOR){
            stepDetector = event.values;
            if (stepDetector[0] >= 1){
                if(mInclinationAngle[0] < 60) mCountBadStep++;
                if(mInclinationAngle[1] < 0) mCountBadStep2++;
                if(mGyroX < -200 || mGyroY < -200 || mGyroZ < -200) mCountHeavySteps++;
            }
        }
    }

    public void onAccuracyChanged(Sensor sensor, int inf){

    }

    /**
     * Método auxiliar que comprueba que es un día diferente al último registrado
     * @param today fecha actual leída
     * @param yesterday última fecha registrada en la db
     * @return devuelve true/false según si el día es diferente o no
     */
    public boolean checkForANewDay(String today, String yesterday){
        String aux1[] = today.split(":");
        String aux2[] = yesterday.split(":");
        boolean answer = false;
        if(today.equals(yesterday)) answer = false;
        else if(aux1[1].equals(aux2[1])){
            if (!aux1[0].equals(aux2[0])) answer = true;
            else answer = false;
        }else if(!aux1[1].equals(aux2[1])){
            answer = true;
        }
        return answer;
    }

    /**
     * Método que asigna un reto al usuario seleccionado mediante el método random configurado
     * para que varie entre 1 y 3
     * @param check boolean para saber si tiene que dar retos o no
     */
    public void GiveMeAChallenge(boolean check){
        if(check){
            mChallengeButton.setEnabled(true);
            mTodaysChallenge = 0;
            int todayChallenge = (int) (Math.random() * 2);
            switch (todayChallenge){
                case 0:
                    //mChallengeButton.setBackground(); //Poner imagen reto uno
                    datos.actualizarRetoDiario(new Usuario(mSelectedId,null,null,null,null,null,null,1, 0));
                    datos.actualizarLastLog(new Usuario(mSelectedId, null, null, null, null, null, mToday, 0, 0));
                    datos.actualizarRetoCompletado(new Usuario(mSelectedId, null, null, null, null, null, null, 0, 0));
                    break;
                case 1:
                    //mChallengeButton.setBackground(); //Poner imagen reto dos
                    datos.actualizarRetoDiario(new Usuario(mSelectedId,null,null,null,null, null,null,2,0));
                    datos.actualizarLastLog(new Usuario(mSelectedId, null, null, null, null,  null, mToday, 0, 0));
                    datos.actualizarRetoCompletado(new Usuario(mSelectedId, null, null, null, null, null, null, 0, 0));
                    break;
                case 2:
                    //mChallengeButton.setBackground(); //Poner imagen reto tres
                    datos.actualizarRetoDiario(new Usuario(mSelectedId,null,null,null,null, null,null,3,0));
                    datos.actualizarLastLog(new Usuario(mSelectedId, null, null, null, null,  null, mToday, 0, 0));
                    datos.actualizarRetoCompletado(new Usuario(mSelectedId, null, null, null, null,  null, null, 0, 0));
                    break;
                default:
                    Log.i("Error", "No challenge asigned");
                    break;
            }
        }
    }

    /**
     * Método llamado cuando se pulsa el botón configuración de la interfaz de usuario
     * @param view botón que se ha pulsado
     */
    public void launchConfigDialog(View view){

        //Create the dialog
        final Dialog dialog = new Dialog(MainActivity.this);
        //Setting custom layout do gialog
        dialog.setContentView(R.layout.config_user_dialog);
        //Configuring textviews
        TextView Actualusuer = (TextView)dialog.findViewById(R.id.TextTitleCofingUser);
        Actualusuer.setText(getSpecifiedUserforId(mSelectedId) + ":");
        TextView CurrentHeight = (TextView)dialog.findViewById(R.id.TextoConfigAlturaActual);
        CurrentHeight.setText(getSpecifiedUserHeight(mSelectedId) + " cm");
        TextView CurrentWeight = (TextView)dialog.findViewById(R.id.TextoConfigPesoActual);
        CurrentWeight.setText(getSpecifiedUserWeight(mSelectedId) + " kg");
        TextView CurrentZancada = (TextView)dialog.findViewById(R.id.TextoConfigZancadaActual);
        int aux = Integer.parseInt(getSpecifiedZancada(mSelectedId).trim());
            if(aux == 0 || aux > 120)
                CurrentZancada.setText(getString(R.string.strideDeviceDefault));
            else
                CurrentZancada.setText(String.valueOf(aux) + " cm");

        //Config EditTexts
        final EditText NuevaAltura = (EditText) dialog.findViewById(R.id.EditConfigNuevaAltura);
        final EditText NuevoPeso = (EditText) dialog.findViewById(R.id.EditConfigNuevoPeso);
        final EditText NuevaZancada = (EditText) dialog.findViewById(R.id.EditConfigZancadaActual);

        NuevaAltura.setEnabled(true);
        NuevoPeso.setEnabled(true);
        NuevaZancada.setEnabled(true);

        //Config About
        ImageButton ConfigAbout = (ImageButton)dialog.findViewById(R.id.ConfigInfoButton);
        ConfigAbout.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                final AlertDialog.Builder builder = new AlertDialog.Builder(MainActivity.this);
                builder.setTitle(R.string.configAboutStrideTitle);
                builder.setMessage(R.string.aboutConfig);
                builder.setPositiveButton(android.R.string.ok, null);
                builder.setOnDismissListener(new DialogInterface.OnDismissListener() {

                    @Override
                    public void onDismiss(DialogInterface dialog) {
                    }

                });
                builder.show();
            }
        });

        //Config dismiss button
        //Dismiss button
        Button confirmButton = (Button)dialog.findViewById(R.id.BotonConfirmarCambiosConfig);
        confirmButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //Configuring EditTexts
                if (!mSelectedId.equals("") || mSelectedId != null) {
                    int nuevazancada = 0;
                    String nuevaaltura = NuevaAltura.getText().toString();
                    String nuevopeso = NuevoPeso.getText().toString();
                    if (!NuevaZancada.getText().toString().equals("")) {
                        nuevazancada = Integer.valueOf(NuevaZancada.getText().toString());
                        if (nuevazancada == 0 || nuevazancada > 120) nuevazancada = 0;
                    }

                    if (nuevaaltura.equals("")) nuevaaltura = getSpecifiedUserHeight(mSelectedId);
                    if (nuevopeso.equals("")) nuevopeso = getSpecifiedUserWeight(mSelectedId);

                    datos.actualizarUsuario(new Usuario(mSelectedId, null, null, nuevaaltura, nuevopeso,  null, null, 0,0));
                    datos.actualizarZancada(mSelectedId, String.valueOf(nuevazancada));
                    dialog.dismiss();
                } else {
                    Log.i("ERROR", "No ID");
                }
            }
        });

        Button cancelButton = (Button)dialog.findViewById(R.id.BotonCancelarCambiosConfig);
        cancelButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                dialog.dismiss();
            }
        });
        dialog.show();
    }

    /**
     * AlertDialog creado cuando el usuario accede a la interfaz y tiene como reto a completar
     * el primero.
     */
    public void isAfirstChallenge (){
        // Initializing dialog
        final Dialog dialog = new Dialog(MainActivity.this);
        //Configuring view of the dialog
        dialog.setContentView(R.layout.first_challenge_dialog);
        dialog.setTitle("First challenge");
        //Configuring text on dialog
        TextView km_recorridos = (TextView)dialog.findViewById(R.id.DisplayFirstChallengekm);
        double totalDistance =   getTodaysDistance();
        km_recorridos.setText(String.format("%.2f", totalDistance));

        //Configure dismiss button
        Button Dissmiss = (Button)dialog.findViewById(R.id.FirstChallengeDismissButton);
        Dissmiss.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                dialog.dismiss();
            }
        });
        mChallengeButton.setBackgroundResource(R.drawable.challenge_1);
        mChallengeButton.setEnabled(true);
        dialog.show();
    }

    /**
     * AlertDialog creado cuando el usuario accede a la interfaz y tiene como reto a completar
     * el segundo.
     */
    public void isSecondChallenge (){
        // Initializing dialog
        final Dialog dialog = new Dialog(MainActivity.this);
        //Configuring view of the dialog
        dialog.setContentView(R.layout.second_challenge_dialog);
        dialog.setTitle("Second challenge");
        //Configuring text on dialog
        TextView km_recorridos = (TextView)dialog.findViewById(R.id.DisplaySecondChallengecal);
        double totalcal = getTodaysCalories();
        km_recorridos.setText(String.format("%.2f", totalcal));
        //Configure dismiss button
        Button Dissmiss = (Button)dialog.findViewById(R.id.SecondChallengeDismissButton);
        Dissmiss.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                dialog.dismiss();
            }
        });
        mChallengeButton.setBackgroundResource(R.drawable.challenge_2);
        mChallengeButton.setEnabled(true);
        dialog.show();
    }

    /**
     * AlertDialog creado cuando el usuario accede a la interfaz y tiene como reto a completar
     * el tercero.
     */
    public void isThirdChallenge (){
        // Initializing dialog
        final Dialog dialog = new Dialog(MainActivity.this);
        //Configuring view of the dialog
        dialog.setContentView(R.layout.third_challenge_dialog);
        dialog.setTitle("Third challenge");
        //Configure dismiss button
        Button Dissmiss = (Button)dialog.findViewById(R.id.ThirdChallengeDismissButton);
        Dissmiss.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                dialog.dismiss();
            }
        });
        mChallengeButton.setBackgroundResource(R.drawable.challenge_3);
        mChallengeButton.setEnabled(true);
        dialog.show();
    }

    /**
     * Método llamado cuando se pulsa el botón de borrado en la interfaz de usuario
     */

    public void launchDeleteDialog(View view){
        //Create the dialog
        final Dialog dialog = new Dialog(MainActivity.this);
        //Setting custom layout do gialog
        dialog.setContentView(R.layout.eraser_dialog);
        //Configuring user delete
            //Configuring Spinners
            //Primer spinner --> Usuarios
            Spinner spinner_usuarios_borrar = (Spinner) dialog.findViewById(R.id.DeleteUserSpinner);
            if (mUsers!=null) {
            ArrayAdapter<String> adapter_selected = new ArrayAdapter<String>(MainActivity.this,
                    android.R.layout.simple_spinner_item, mUsers);
            adapter_selected.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
                spinner_usuarios_borrar.setAdapter(adapter_selected);
            }
            /** Spinner OnSelectedItem Listener **/
            spinner_usuarios_borrar.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
                @Override
                public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                    deleteName = mUsers[position];
                    //String[] aux = getAllIdForSpinner();
                    //deleteName = aux[position];
                }

                @Override
                public void onNothingSelected(AdapterView<?> parent) {

                }
            });
            //Configuring Button
            //UserDeleteButton
            Button userDeleteButton = (Button)dialog.findViewById(R.id.DeleteUserConfirmButton);
            userDeleteButton.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    if (mUsers.length > 1) {
                        final AlertDialog.Builder builder = new AlertDialog.Builder(MainActivity.this);
                        builder.setTitle(getString(R.string.deleteAUserAlertDialogTitle));
                        builder.setMessage(getString(R.string.deleteAUserAlertDialogDescription));
                        builder.setPositiveButton(android.R.string.ok, new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                datos.eliminarUsuarioporNombre(deleteName);
                                MainActivity.this.finishAffinity();
                            }
                        });
                        builder.setNegativeButton(android.R.string.cancel, new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                dialog.dismiss();
                            }
                        });
                        builder.setOnDismissListener(new DialogInterface.OnDismissListener() {
                            @Override
                            public void onDismiss(DialogInterface dialog) {

                            }

                        });
                        builder.show();
                    } else {
                        final AlertDialog.Builder builder = new AlertDialog.Builder(MainActivity.this);
                        builder.setTitle(getString(R.string.deleteAUserAlertDialogErrorTitle));
                        builder.setMessage(getString(R.string.deleteAUserAlertDialogErrorDescription));
                        builder.setPositiveButton(android.R.string.ok, null);
                        builder.setOnDismissListener(new DialogInterface.OnDismissListener() {
                            @Override
                            public void onDismiss(DialogInterface dialog) {
                            }
                        });
                        builder.show();
                    }

                }
            });

        //Configure delete all Performance
        Button destroyerOfMemories = (Button)dialog.findViewById(R.id.DeletePerformanceConfirmButton);
        destroyerOfMemories.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                final AlertDialog.Builder builder = new AlertDialog.Builder(MainActivity.this);
                builder.setTitle(getString(R.string.deleteAllPerformanceTitle));
                builder.setMessage(getString(R.string.deleteAllPerformanceDescription));
                builder.setPositiveButton(android.R.string.ok, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        mBase.DeletePerformance(datos.getDb());
                        MainActivity.this.finishAffinity();
                    }
                });
                builder.setNegativeButton(android.R.string.cancel, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        dialog.dismiss();
                    }
                });
                builder.setOnDismissListener(new DialogInterface.OnDismissListener() {
                    @Override
                    public void onDismiss(DialogInterface dialog) {

                    }

                });
                builder.show();
            }
        });

        //Configure delete all button
        Button DetroyerOfWorlds = (Button)dialog.findViewById(R.id.DeleteAllConfirmButton);
        DetroyerOfWorlds.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                final AlertDialog.Builder builder = new AlertDialog.Builder(MainActivity.this);
                builder.setTitle(getString(R.string.deleteAllDataTitle));
                builder.setMessage(getString(R.string.deleteAllDataDescription));
                builder.setPositiveButton(android.R.string.ok, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        int aux = mBase.getVersionActual();
                        int aux2 = 0;
                        if (aux <= 5) aux2 = aux++;
                        else aux2 = 1;

                        mBase.onUpgrade(datos.getDb(), aux, aux2);
                        MainActivity.this.finishAffinity();
                    }
                });
                builder.setNegativeButton(android.R.string.cancel, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        dialog.dismiss();
                    }
                });
                builder.setOnDismissListener(new DialogInterface.OnDismissListener() {
                    @Override
                    public void onDismiss(DialogInterface dialog) {

                    }

                });
                builder.show();
            }
        });
        //Set dismiss button
        Button deleteDismiss = (Button)dialog.findViewById(R.id.DeleteDismissButton);
        deleteDismiss.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                dialog.dismiss();
            }
        });
        dialog.show();

    }

    /**
     * Llamada al AlertDialog para el recuento de datos del usuario
     * @param view botón pulsado
     */
    public void launchUseTotalRecap(View view){
        final Dialog dialog = new Dialog(MainActivity.this);
        //Setting custom layout do gialog
        dialog.setContentView(R.layout.performance_user_dialog);
        //Configuring textviews
        //First textview pasos totales
        TextView pasostotales = (TextView)dialog.findViewById(R.id.DisplayAllCurrentSteps);
        pasostotales.setText(String.valueOf(getAllCurrentSteps()));

        //Second textview %badsteps and info about
        TextView porctjbdsteps = (TextView)dialog.findViewById(R.id.DisplayAllCurrentBadSteps);
        if(getAllCurrentSteps() <= 0){
            porctjbdsteps.setText("0%");
        }else {
            double percentbdsteps = (1-((((double)getAllCurrentSteps()) - ((double)getAllCurrentBadSteps()))/((double)getAllCurrentSteps())))*100;
            porctjbdsteps.setText(String.format("%.2f",percentbdsteps) + "%");
        }
            //Set up of about
            ImageButton aboutbadsteps = (ImageButton)dialog.findViewById(R.id.AboutBadSteps);
            aboutbadsteps.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    final AlertDialog.Builder builder = new AlertDialog.Builder(MainActivity.this);
                    builder.setTitle(R.string.recapAboutBadStepsTitle);
                    String aux = getString(R.string.badstepsabout1);
                    String aux1 = getString(R.string.badstepsabout2);
                    String aux2 = getString(R.string.badstepsabout3);
                    String aux3;
                    if (getAllCurrentSteps() <= 0 || getAllCurrentBadSteps() <= 0) {
                        aux3 = aux + "\n\n" + aux2 + " 0%\n\n" + aux1;
                    } else {
                        aux3 = aux + "\n\n" + aux2 + " " +
                                String.format("%.2f", (1 - ((((double) getAllCurrentSteps()) - ((double) getAllCurrentBadSteps())) / ((double) getAllCurrentSteps()))) * 100)
                                + "%\n\n" + aux1;
                    }

                    builder.setMessage(aux3);
                    builder.setPositiveButton(android.R.string.ok, new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            dialog.dismiss();
                        }
                    });
                    builder.show();
                }
            });
        //Third textview %heel steps and info about
        TextView porctjheelsteps = (TextView)dialog.findViewById(R.id.DisplayAllCurrentBadSteps2);
        if(getAllCurrentSteps() <= 0){
            porctjheelsteps.setText("0%");
        }else {
            double percentheelsteps = (1-((((double)getAllCurrentSteps()) - ((double)getAllCurrentBadSteps2()))/((double)getAllCurrentSteps())))*100;
            porctjheelsteps.setText(String.format("%.2f",percentheelsteps) + "%");
        }
        //Set up of about
        ImageButton aboutbadsteps2 = (ImageButton)dialog.findViewById(R.id.AboutBadSteps2);
        aboutbadsteps2.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                final AlertDialog.Builder builder = new AlertDialog.Builder(MainActivity.this);
                builder.setTitle(R.string.recapAboutHeelStepsTitle);
                String aux = getString(R.string.heelsStepsAbout1);
                String aux1 = getString(R.string.heelsStepsAbout2);
                String aux2 = getString(R.string.heelsStepsAbout3);
                String aux3;
                if (getAllCurrentSteps() <= 0 || getAllCurrentBadSteps2() <= 0){
                    aux3 = aux + "\n\n" + aux2 + " 0%\n\n" + aux1;
                }else{
                    aux3 = aux + "\n\n" + aux2 + " " +
                            String.format("%.2f",(1-((((double)getAllCurrentSteps()) - ((double)getAllCurrentBadSteps2()))/((double)getAllCurrentSteps())))*100)
                            + "%\n\n" + aux1;
                }

                builder.setMessage(aux3);
                builder.setPositiveButton(android.R.string.ok, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        dialog.dismiss();
                    }
                });
                builder.show();
            }
        });
        //Fourth textview %heavysteps and info about
        TextView porctjhysteps = (TextView)dialog.findViewById(R.id.DisplayAllCurrentHeavySteps);
        if(getAllCurrentSteps() <= 0 || getAllCurrentHeavySteps() <= 0){
            porctjhysteps.setText("0%");
        }else {
            double percenthysteps = (1-(((double)getAllCurrentSteps() - (double)getAllCurrentHeavySteps()) / (double)getAllCurrentSteps()))*100;
            porctjhysteps.setText(String.format("%.2f",percenthysteps) + "%");
        }
        //Set up of about
        ImageButton aboutheavysteps = (ImageButton)dialog.findViewById(R.id.AboutHeavySteps);
        aboutheavysteps.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                final AlertDialog.Builder builder = new AlertDialog.Builder(MainActivity.this);
                builder.setTitle(R.string.recapAboutHeavyStepsTitle);
                String aux = getString(R.string.heavystepsabout1);
                String aux1 = getString(R.string.heavystepsabout2);
                String aux2 = getString(R.string.heavystepsabout3);
                String aux3;
                if (getAllCurrentSteps() <= 0) {
                    aux3 = aux + "\n\n" + aux1 + " 0%\n\n" + aux2;
                } else {
                    aux3 = aux + "\n\n" + aux1 + " " +
                            String.format("%.2f",((1-((double)getAllCurrentSteps() - (double)getAllCurrentHeavySteps()) / (double)getAllCurrentSteps()))*100)
                            + "%\n\n" + aux2;
                }

                builder.setMessage(aux3);
                builder.setPositiveButton(android.R.string.ok, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        dialog.dismiss();
                    }
                });
                builder.show();
            }
        });

        //Fifth textview, total distancia
        TextView totaldistancia = (TextView)dialog.findViewById(R.id.DisplayAllCurrentDistance);
        totaldistancia.setText(String.format("%.2f", getAllCurrentDistance()));

        //Sixth textview, total BurnedCal
        TextView totalburnedcal = (TextView)dialog.findViewById(R.id.DisplayAllBurnedCal);
        totalburnedcal.setText(String.format("%.2f", getAllBurnedCalories()));

        //Dismissbutton
        Button dismissButton = (Button)dialog.findViewById(R.id.DismissDisplayRecap);
        dismissButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                dialog.dismiss();
            }
        });

        dialog.show();
    }

    /**
     * Activación del AlertDialog que explica en que consiste en reto a completar
     * @param view botón pulsado
     */
    public void launchChallengeDialogButton(View view){
        String aux;
        String aux1;
        String aux2;
        switch (mTodaysChallenge){
            case 1:
                final AlertDialog.Builder builder = new AlertDialog.Builder(MainActivity.this);
                builder.setTitle(R.string.firstchallenge0);
                aux = getString(R.string.firstchallenge1);
                aux1 = getString(R.string.firstchallenge2);
                aux2 = aux + "\n\n" + aux1 + " " + String.format("%.2f",getTodaysDistance()) + "/10 km.";
                builder.setMessage(aux2);
                builder.setPositiveButton(android.R.string.ok, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        dialog.dismiss();
                    }
                });
                builder.show();
                break;
            case 2:
                final AlertDialog.Builder builder1 = new AlertDialog.Builder(MainActivity.this);
                builder1.setTitle(R.string.secondchallenge0);
                aux = getString(R.string.secondchallenge1);
                aux1 = getString(R.string.secondchallenge2);
                aux2 = aux + "\n\n" + aux1 + " " + String.format("%.2f", getTodaysCalories()) + "/500 cal.";
                builder1.setMessage(aux2);
                builder1.setPositiveButton(android.R.string.ok, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        dialog.dismiss();
                    }
                });
                builder1.show();
                break;
            case 3:
                final AlertDialog.Builder builder2 = new AlertDialog.Builder(MainActivity.this);
                builder2.setTitle(R.string.thirdchallenge0);
                aux = getString(R.string.thirdchallenge1);
                aux1 = getString(R.string.secondchallenge2);
                aux2 = aux + "\n\n" + aux1 +" 0/1 completed.";
                builder2.setMessage(aux2);
                builder2.setPositiveButton(android.R.string.ok, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        dialog.dismiss();
                    }
                });
                builder2.show();
                break;
            default:
                final AlertDialog.Builder builder3 = new AlertDialog.Builder(MainActivity.this);
                builder3.setTitle("Error");
                builder3.setMessage("No challenge acknowledge");
                builder3.setPositiveButton(android.R.string.ok, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        dialog.dismiss();
                    }
                });
                builder3.show();
                break;
        }
    }

    /**
     * Consigue la distancia recorrida en este día
     * @return la distancia total recorrida
     */
    public double getTodaysDistance() {
        String aux[];
        String aux2[];
        aux = getLastPerformanceDates();
        String today = new SimpleDateFormat("dd/MM/yyyy").format(new Date());
        today += " ";
        double totalDistance = 0;
        if (aux[0] != null) {
            for (int i = 0; i < aux.length; i++) {
                if (aux[i] != null) {
                    aux2 = aux[i].split("-");
                    if (aux2[0].equals(today)) {
                        totalDistance = totalDistance + getSpecifiedPerformanceDistance(aux[i]);
                    }
                }
            }
        }
        return totalDistance;
    }

    /**
     * Consigue las calorías quemadas en este día
     * @return suma total de calorías
     */
    public double getTodaysCalories(){
        String aux[];
        String aux2[];
        double totalcal = 0;
        aux = getLastPerformanceDates();
        String today = new SimpleDateFormat("dd/MM/yyyy").format(new Date());
        today += " ";
        if (aux != null) {
            if (aux[0] != null) {
                for (int i = 0; i < aux.length; i++) {
                    if(aux[i]!= null) {
                        aux2 = aux[i].split("-");
                        if (aux2[0].equals(today)) {
                            totalcal = totalcal + getSpecifiedBurnedCalories(aux[i]);
                        }
                    }
                }

            }
        }

        return totalcal;
    }

    /**
     * Método llamado cuando el usuario comienza actividad. Guarda un registro @mStartTime, de
     * cuando se ha comenzado la actividad
     * @param view botón pulsado.
     */
    public void StartAnewPerformance(View view){
        //Set stop button enabled and start button disabled
        mStopActivity.setEnabled(true);
        mStartActivity.setEnabled(false);
        //Attach movements sensors
        mSensorManager.registerListener(this, mStepCounterSensor,
                SensorManager.SENSOR_DELAY_NORMAL);
        mSensorManager.registerListener(this, mStepDetectorSensor,
                SensorManager.SENSOR_DELAY_NORMAL);
        //Get relative time and date
        mStartTime = new Date().getTime();

    }

    /**
     * Método llamado cuando el usuario finaliza la actividad.
     * @param view Botón pulsado
     */
    public void StopThePerformance(View view){
        //Set stop button disabled and start button enabled
        mStopActivity.setEnabled(false);
        mStartActivity.setEnabled(true);
        //Detach movement sensors
        /** Register and Unregister Sensors **/
        mSensorManager.unregisterListener(this, mStepCounterSensor);
        mSensorManager.unregisterListener(this, mStepDetectorSensor);
        //Get relative time
        mFinishTime = new Date().getTime();
        double time_wasted = mFinishTime - mStartTime;
        //Get date
        mActivityDate = new SimpleDateFormat("dd/MM/yyyy '-' HH:mm:ss").format(new Date());
        //Get distance
        double userheigth = Double.parseDouble(getSpecifiedUserHeight(mSelectedId).trim());
        String StepLength = getSpecifiedZancada(mSelectedId);
        double userStepLength = Double.parseDouble(StepLength.trim());
        double distance = 0;
        DecimalFormat twoDForm = new DecimalFormat("#.##");
        if(userStepLength <= 0){
            distance =  (mCountSteps * 0.414 * userheigth) / 100000;
        }else{
            distance = (mCountSteps * userStepLength) / 100000;
        }
        //Get burned calories
        double userweight = Double.parseDouble(getSpecifiedUserWeight(mSelectedId).trim());
        double burnedCalories = 0;
        burnedCalories = USER_CAL_RATIO * userweight * distance * KM_TO_MILE_RATIO;
        //Inserting new perfomance data
        datos.insertarRendimiento(new RendimientoUsuario(null, mSelectedUser, mActivityDate, mCountSteps, mCountBadStep, mCountBadStep2, mCountHeavySteps, distance, burnedCalories));
        //Launching dialog for user information
        final Dialog dialog = new Dialog(MainActivity.this);
        //Setting custom layout do gialog
        dialog.setContentView(R.layout.finish_perfomance_dialog);
        //Setting textviews for the dialog
        TextView title_performance = (TextView)dialog.findViewById(R.id.FinishedPerfomanceDate);
        title_performance.setText(mActivityDate);
        TextView distance_runned = (TextView)dialog.findViewById(R.id.displayLastPerfomanceDistance);
        distance_runned.setText(String.format("%.1f", distance));
        TextView total_steps = (TextView)dialog.findViewById(R.id.displayLastPerfomanceSteps);
        total_steps.setText(String.valueOf(mCountSteps));
        TextView total_bad_steps = (TextView)dialog.findViewById(R.id.displayLastPerfomanceBadSteps);
        total_bad_steps.setText(String.valueOf(mCountBadStep));
        TextView total_bad_steps_2 = (TextView)dialog.findViewById(R.id.displayLastPerfomanceBadSteps2);
        total_bad_steps_2.setText(String.valueOf(mCountBadStep2));
        TextView total_heavy_steps = (TextView)dialog.findViewById(R.id.displayLastPerfomanceHeavySteps);
        total_heavy_steps.setText(String.valueOf(mCountHeavySteps));
        TextView total_calories = (TextView)dialog.findViewById(R.id.displayLastPerfomanceBurnedCal);
        total_calories.setText(String.format("%.1f", burnedCalories));
        TextView total_time_wasted = (TextView)dialog.findViewById(R.id.displayLastPerfomanceTimeWasted);
        total_time_wasted.setText(String.format("%.0f", convertMilisecondstoMinutes(time_wasted)));
        //Setting dismiss button and listener
        Button dismiss_button = (Button)dialog.findViewById(R.id.lastperfomancedismissbutton);
        dismiss_button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                dialog.dismiss();
            }
        });
        dialog.show();
        //Check for completed challenges
        int aux = getSpecifiedUserChallenge(mSelectedId);
        switch (aux){
            case 1:
                double aux2 = getAllDistanceForToday(mActivityDate);
                if(aux2 >= 10) datos.actualizarRetoCompletado(new Usuario(null, null, null, null, null, null, null, 0, 1));
                break;
            case 2:
                double aux1 = getAllBurnedCaloriesForToday(mActivityDate);
                if(aux1 >= 500) datos.actualizarRetoCompletado(new Usuario(null, null, null, null, null, null, null, 0, 1));
                break;
            case 3:
                double aux3 = distance/convertMilisecondstoMinutes(time_wasted);
                double aux4 = aux3 * 10;
                if(aux4 >= 3) datos.actualizarRetoCompletado(new Usuario(null, null, null, null, null, null, null, 0, 1));
                break;
            default:
                Log.i("Error", "No challenge found");
                break;
        }
        //Resetin count steps and flags;
        mCountSteps = 0;
        mCountBadStep = 0;
        mCountBadStep2 = 0;
        mCountHeavySteps = 0;
        mFinishTime = 0;
        mStartTime = 0;
        AndroidSensorBooted = false;
    }

    /**
     * Método auxiliar para convertir milisegundos a minutos
     * @param miliseconds cantidad de milisegundos a convertir
     * @return milisegundos en minutos
     */
    public double convertMilisecondstoMinutes(double miliseconds){
       return (miliseconds/60000);
    }
}