package com.pruebasaplicacion.sergimeli.bletests.modelo;


/**
 * Created by Elerionfly on 01/08/2016.
 * Modelo utilizado en la base de datos para la creación de un nuevo rendimiento del usuario
 */
public class RendimientoUsuario {
    public String idDatosUsuario;
    public String mNombre;
    public String mDate;
    public int mSteps;
    public int mBadSteps;
    public int mBadSteps2;
    public int mHeavySteps;
    public double mDistance;
    public double mBurnedCalories;

    /**
     * Constructor principal del rendimiento del Usuario que necesita de:
     * @param idDatosUsuario el id correspondiente a la actividad (PK)
     * @param mNombre nombre correspiendte al usuario realizando la actividad (FK)
     * @param mDate fecha en la que se ha realizado la actividad. Formato: "dd/MM/yyyy - HH:mm:ss"
     * @param mSteps número de pasos dados en la actividad
     * @param mBadSteps número de pasos dados de puntillas en la actividad
     * @param mBadSteps2 número de pasos con talón dados en la actividad
     * @param mHeavySteps número de pasos pesados dados en la actividad
     * @param mDistance distancia recorrida durante la actividad
     * @param mBurnedCalories calorías quemadas durante la actividad
     */
    public RendimientoUsuario(String idDatosUsuario,
                              String mNombre,
                              String mDate,
                              int mSteps,
                              int mBadSteps,
                              int mBadSteps2,
                              int mHeavySteps,
                              double mDistance,
                              double mBurnedCalories){

        this.idDatosUsuario = idDatosUsuario;
        this.mNombre = mNombre;
        this.mDate = mDate;
        this.mSteps = mSteps;
        this.mBadSteps = mBadSteps;
        this.mBadSteps2 = mBadSteps2;
        this.mHeavySteps = mHeavySteps;
        this.mDistance = mDistance;
        this.mBurnedCalories = mBurnedCalories;
    }
}
