package com.pruebasaplicacion.sergimeli.bletests.sqlite;

import java.util.Date;
import java.util.UUID;

/**
 * Clase que establece los nombres a usar en la base de datos
 * Created by Elerionfly on 22/07/2016.
 */
public class DeviceContract {

    interface ColumnasDatosDispositivo{
        String MDEVICE= "mDevice";
        String MSERVICEUUID = "mServiceUUID";
        String MDEVICENAME = "mDeviceName";
        String GIVENNAME = "GivenName";
    }

    interface ColumnasUsuario{
        String ID = "id";
        String USUARIO_DEVICE = "Usuario_Device";
        String NOMBRE = "Nombre";
        String ALTURA = "Altura";
        String PESO = "Peso";
        String ZANCADA = "Zancada";
        String LASTLOG = "Lastlog";
        String RETODIARIO = "Reto_Diario";
        String RETOCOMPLTADO = "Reto_Completado";
    }

    interface ColumnasRendimientoUsuario{
        String ID = "id";
        String NOMBRE = "Nombre";
        String FECHA = "Fecha";
        String PASOS = "Pasos";
        String PASOS_MALOS = "Pasos_malos";
        String PASOS_MALOS_2 = "Pasos_malos_talon";
        String PASOS_PESADOS = "Pasos_pesados";
        String DISTANCIA = "Distancia";
        String CALORIAS_QUEMADAS = "Calorias_quemadas";
    }

    public static class DatosDispositivos implements  ColumnasDatosDispositivo{
        /** Devuelve una ID aleatoria **/
        public static String generarIdDatosDispotivos(){
            return "DD-" + UUID.randomUUID().toString();
        }
    }

    public static class Usuarios implements ColumnasUsuario{
        /** Devuelve una ID aleatoria **/
        public static String generarIdCoUsuarios(){
            return "U-" + UUID.randomUUID().toString();
        }
    }

    public static class RendimientoUsuarios implements ColumnasRendimientoUsuario{
        /** Devuelve una ID aleatoria **/
        public static String generarIdRenUsuario(){
            return "RU-" + UUID.randomUUID().toString();
        }
    }
}
